/* WebMail/2 v1.0 by sehh <sehh@altered.com> */

AuthenticationServer_Host = 10.10.10.1
AuthenticationServer_Port = 1924

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
call SockLoadFuncs
Globals.!myinfo = "WebMail/2 v1.0 beta 4 for OS/2"
Globals.!requestmethod = value("REQUEST_METHOD",,'os2environment')
if Globals.!requestmethod="POST" then Globals.!querystring=linein()
else Globals.!querystring = value("QUERY_STRING",,'os2environment')
parse value Globals.!querystring with Globals.!stat1 "&" Globals.!user "&" Globals.!pazz "&" Globals.!stat2
Globals.!mail.0 = 0
Globals.!totalmail = 0
Globals.!serv = AuthenticationServer_Host
Globals.!port = AuthenticationServer_Port
Globals.!myself = value("SCRIPT_NAME",,'os2environment')
Globals.!ETC = value("ETC",,'os2environment')
if pos(Globals.!myself,value("HTTP_REFERER",,'os2environment'))<1 then call UserLoginScreen
else if pos("flogin=",Globals.!stat1)>0 & Globals.!stat2="" then call CheckLogon("fcheckemail")
else if pos("refresh",Globals.!stat1)>0 & Globals.!stat2="" then call CheckLogon("checkemail")
else if pos("read",Globals.!stat1)>0 & Globals.!stat2<>"" then call CheckLogon("read")
else if pos("new",Globals.!stat1)>0 & Globals.!stat2="" then call CheckLogon("new")
else if pos("newpost",Globals.!stat1)>0 & Globals.!stat2<>"" then call CheckLogon("newpost")
else if pos("delete",Globals.!stat1)>0 & Globals.!stat2<>"" then call CheckLogon("delete")
else if pos("logoff",Globals.!stat1)>0 & Globals.!stat2="" then call CheckLogon("logoff")
call UserLoginScreen
return

CheckLogon: procedure expose Globals.
Globals.!user = substr(Globals.!user,3,length(Globals.!user)-2)
Globals.!pazz = substr(Globals.!pazz,3,length(Globals.!pazz)-2)
Globals.!pop3 = ""
Globals.!pop3p = ""
Globals.!smtp = ""
Globals.!smtpp = ""
rc = SockGetHostByName(Globals.!serv,"host.!")
if (rc = 0) then call CGIErrorScreen("Error in hostname/ip resolv")
server = host.!addr;
port = Globals.!port
socket  = SockSocket("AF_INET","SOCK_STREAM",0)
if (socket = -1) then call CGIErrorScreen("Error open socket")
server.!family = "AF_INET"
server.!port   = port
server.!addr   = server
rc = SockConnect(socket,"server.!")
if (rc = -1) then call CGIErrorScreen("Error on Socket/Port Connection "||port)
Globals.!clientIP = value("REMOTE_ADDR",,'os2environment')
if Globals.!clientIP = "" then call ServerErrorScreen("Can't detect your client")
if ARG(1) = "fcheckemail" then tmp1=0
else if ARG(1) = "logoff" then tmp1=2
else tmp1=1
call SendData(Globals.!user||":"||Globals.!pazz||":"||Globals.!clientIP||":"||tmp1||":")
if tmp1<>2 then do
 call ReceiveData
 if pos("[WebManager2] OK",newData)<1 then do
  call SysSleep 6
  call ServerErrorScreen("Login refused")
 end
 parse value newData with okmsg ":" Globals.!pop3 ":" Globals.!pop3p ":" Globals.!smtp ":" Globals.!smtpp ":"
 rc = SockSoClose(socket)
 if (rc = -1) then call CGIErrorScreen("Error on SockSoClose")
 if ARG(1) = "checkemail" | ARG(1) = "fcheckemail" then call CheckEmail
 else if ARG(1) = "read" then call ReceiveEmail
 else if ARG(1) = "new" then call NewEmailScreen
 else if ARG(1) = "newpost" then call NewEmail
 else if ARG(1) = "delete" then call DeleteEmail
end; else do
 call UserLoginScreen
end
call SysSleep 6
call ServerErrorScreen("Login refused")
return

NewEmail: procedure expose Globals.
parse value Globals.!stat2 with "t=" sendto "&s=" subject "&body=" body
rc = SockGetHostByName(Globals.!smtp,"host.!")
if (rc = 0) then call CGIErrorScreen("Error in hostname/ip resolv")
server = host.!addr;
port = Globals.!smtpp
socket  = SockSocket("AF_INET","SOCK_STREAM",0)
if (socket = -1) then call CGIErrorScreen("Error open socket")
server.!family = "AF_INET"
server.!port   = port
server.!addr   = server
rc = SockConnect(socket,"server.!")
if (rc = -1) then call CGIErrorScreen("Error on Socket/Port Connection")
call ReceiveData
if substr(newData,1,3)<>"220" then call ServerErrorScreen("Server refused connection")
call SendData("HELO "||server||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server dropped connection")
end
call SendData("MAIL FROM: <"||Globals.!user||"@"||value("SERVER_NAME",,'os2environment')||">"||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server rejected email transfer")
end
call SendData("RCPT TO: <"||sendto||">"||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server rejected target email")
end
call SendData("DATA"||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"354" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server rejected email data")
end
header = "From: <"||Globals.!user||"@"||value("SERVER_NAME",,'os2environment')||">"||'0d0a'x
header = header||"To: <"||sendto||">"||'0d0a'x
header = header||"Date: "||substr(date("W"),1,3)||", "||date('N')||" "||time()||" "||value("TZ",,'os2environment')||'0d0a'x
header = header||"Priority: Normal"||'0d0a'x
header = header||"X-Mailer: "||Globals.!myinfo||'0d0a'x
header = header||"Content-Type: text/plain"||'0d0a'x
header = header||"Subject: "||subject||'0d0a'x||'0d0a'x
body = URLDecode(body)
body=header||body
call SendData(body)
call SendData('0d0a'x||"."||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server rejected email transfer")
end
call SendData("QUIT"||'0d0a'x)
rc = SockSoClose(socket)
if (rc = -1) then call CGIErrorScreen("Error on SockSoClose")
call CheckEmail
return

ReceiveEmail: procedure expose Globals.
rc = SockGetHostByName(Globals.!pop3,"host.!")
if (rc = 0) then call CGIErrorScreen("Error in hostname/ip resolv")
server = host.!addr;
port = Globals.!pop3p
socket  = SockSocket("AF_INET","SOCK_STREAM",0)
if (socket = -1) then call CGIErrorScreen("Error open socket")
server.!family = "AF_INET"
server.!port   = port
server.!addr   = server
rc = SockConnect(socket,"server.!")
if (rc = -1) then call CGIErrorScreen("Error on Socket/Port Connection")
call ReceiveData
if substr(newData,1,3)<>"+OK" then call ServerErrorScreen("Server refused connection")
call SendData("USER "||Globals.!user||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server refused user login")
end
call SendData("PASS "||Globals.!pazz||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Failed login due to password error")
end
call SendData("RETR "||Globals.!stat2||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server couldn't retrieve email")
end
call ReceiveData
call SendData("QUIT"||'0d0a'x)
rc = SockSoClose(socket)
if (rc = -1) then call CGIErrorScreen("Error on SockSoClose")
call ReadEmailScreen(newData)
return

DeleteEmail: procedure expose Globals.
rc = SockGetHostByName(Globals.!pop3,"host.!")
if (rc = 0) then call CGIErrorScreen("Error in hostname/ip resolv")
server = host.!addr;
port = Globals.!pop3p
socket  = SockSocket("AF_INET","SOCK_STREAM",0)
if (socket = -1) then call CGIErrorScreen("Error open socket")
server.!family = "AF_INET"
server.!port   = port
server.!addr   = server
rc = SockConnect(socket,"server.!")
if (rc = -1) then call CGIErrorScreen("Error on Socket/Port Connection")
call ReceiveData
if substr(newData,1,3)<>"+OK" then call ServerErrorScreen("Server refused connection")
call SendData("USER "||Globals.!user||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server refused user login")
end
call SendData("PASS "||Globals.!pazz||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Failed login due to password error")
end
if pos("all",Globals.!stat2)>0 then do
 call SendData("STAT"||'0d0a'x)
 call ReceiveData
 if substr(newData,1,3)<>"+OK" then do
  call SendData("QUIT"||'0d0a'x)
  call ServerErrorScreen("Email server couldn't get status")
 end
 parse value newData with . Globals.!totalmail .
 if datatype(Globals.!totalmail,"N")<>1 then do
  call SendData("QUIT"||'0d0a'x)
  call ServerErrorScreen("Server returned wrong value")
 end
 do i=1 to Globals.!totalmail
  call SendData("DELE "||i||'0d0a'x)
  call ReceiveData
  if substr(newData,1,3)<>"+OK" then do
   call SendData("QUIT"||'0d0a'x)
   call ServerErrorScreen("Server couldn't delete email<br> or email already deleted")
  end
 end
end; else do
 call SendData("DELE "||Globals.!stat2||'0d0a'x)
 call ReceiveData
 if substr(newData,1,3)<>"+OK" then do
  call SendData("QUIT"||'0d0a'x)
  call ServerErrorScreen("Server couldn't delete email<br> or email already deleted")
 end
end
call SendData("QUIT"||'0d0a'x)
rc = SockSoClose(socket)
if (rc = -1) then call CGIErrorScreen("Error on SockSoClose")
call CheckEmail
return

CheckEmail: procedure expose Globals.
rc = SockGetHostByName(Globals.!pop3,"host.!")
if (rc = 0) then call CGIErrorScreen("Error in hostname/ip resolv")
server = host.!addr;
port = Globals.!pop3p
socket  = SockSocket("AF_INET","SOCK_STREAM",0)
if (socket = -1) then call CGIErrorScreen("Error open socket")
server.!family = "AF_INET"
server.!port   = port
server.!addr   = server
rc = SockConnect(socket,"server.!")
if (rc = -1) then call CGIErrorScreen("Error on Socket/Port Connection"||port)
call ReceiveData
if substr(newData,1,3)<>"+OK" then call ServerErrorScreen("Server refused connection")
call SendData("USER "||Globals.!user||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server refused user login")
end
call SendData("PASS "||Globals.!pazz||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Failed login due to password error")
end
call SendData("STAT"||'0d0a'x)
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Email server couldn't get status")
end
parse value newData with . Globals.!totalmail .
if datatype(Globals.!totalmail,"N")<>1 then do
 call SendData("QUIT"||'0d0a'x)
 call ServerErrorScreen("Server returned wrong value")
end
do i=1 to Globals.!totalmail
 call SendData("TOP "||i||" 1"||'0d0a'x)
 call ReceiveData
 if substr(newData,1,3)="+OK" then do
  call ReceiveData
  Globals.!mail.i = newData
 end
end
Globals.!mail.0 = i
ListMail.0 = 0
do i=1 to Globals.!totalmail
 tmp1 = pos("From:",Globals.!mail.i)+6
 tmp2 = pos('0d0a'x,Globals.!mail.i,tmp1)
 tmp3 = space(substr(Globals.!mail.i,tmp1,tmp2-tmp1))
 ListMail.i.!From = space(substr(tmp3,1,pos("<",tmp3)-1)||"("||substr(tmp3,pos("<",tmp3)+1,(lastpos(">",tmp3))-(pos("<",tmp3)+1))||")")
 tmp1 = pos("Subject:",Globals.!mail.i)+9
 tmp2 = pos('0d0a'x,Globals.!mail.i,tmp1)
 ListMail.i.!Subject = space(substr(Globals.!mail.i,tmp1,tmp2-tmp1))
 tmp1 = pos("Date:",Globals.!mail.i)+6
 tmp2 = pos('0d0a'x,Globals.!mail.i,tmp1)
 ListMail.i.!Date = space(substr(Globals.!mail.i,tmp1,16))
end
call SendData("QUIT"||'0d0a'x)
rc = SockSoClose(socket)
if (rc = -1) then call CGIErrorScreen("Error on SockSoClose")
call CheckScreen
return

SendData: procedure expose socket
rc = SockSend(socket,ARG(1))
if (rc = -1) then call CGIErrorScreen("Error on SockSend")
return

ReceiveData: procedure expose socket newData
length = ARG(1)
if length = "" then length = 1024
rc = SockRecv(socket,"newData",length)
if (rc = -1) then call CGIErrorScreen("Error on SockRecv")
return

ParseHTML: procedure expose Globals. i ListMail.
findstring.1 = "*!WMVERSION!*:"||Globals.!myinfo
findstring.2 = "*!WMUSER!*:"||Globals.!user
findstring.3 = "*!WMPASS!*:"||Globals.!pazz
findstring.4 = "*!WMFILENAME!*:"||Globals.!myself
findstring.5 = "*!WMEMAILNUM!*:"||i
findstring.6 = "*!WMEMAILFROM!*:"||ListMail.i.!From
findstring.7 = "*!WMEMAILSUBJECT!*:"||ListMail.i.!Subject
findstring.8 = "*!WMEMAILDATE!*:"||ListMail.i.!Date
findstring.9 = "*!WMEMAILBODY!*:"||ListMail.!Show
findstring.10 = "*!WMEMAILTABLE!*:"||Globals.!ListTable
findstring.11 = "*!SERVERERROR!*:"||Globals.!ServerErr
findstring.12 = "*!CGIERROR!*:"||Globals.!CGIErr
findstring.0 = 12
if ARG(2)=1 then do
 say "Content-type: text/html"
 say ""
end
newstr = ""
istr = stream(ARG(1), 'c', 'open read')
do while lines(ARG(1))>0
 tmp = linein(ARG(1))
 do ii=1 to findstring.0
  parse value findstring.ii with tmp1 ":" tmp2
  rc = pos(tmp1,tmp)
  if rc >0 then tmp = ReplaceStr(tmp,tmp1,tmp2)
 end
 if ARG(3)<>1 then say tmp
 else newstr = newstr || tmp|| '0d0a'x
end
return newstr

ReplaceStr: procedure
tmp1 = ARG(1)
tmp2 = ARG(2)
tmp3 = ARG(3)
do forever
 iz = pos(tmp2,tmp1)
 if iz<1 then leave
 tmp = substr(tmp1,1,iz-1)
 tmpp = substr(tmp1,iz+length(tmp2),length(tmp1)-iz+length(tmp2))
 tmp1 = tmp||tmp3||tmpp
end
return tmp1

UserLoginScreen: procedure expose Globals.
call ParseHTML Globals.!ETC || "\webmailhtml\userlogin.wm", 1
exit

CheckScreen: procedure expose Globals. ListMail.
call ParseHTML Globals.!ETC || "\webmailhtml\header.wm", 1
if Globals.!totalmail > 0 then do
 Globals.!ListTable = ""
 do i=1 to Globals.!totalmail
  Globals.!ListTable = Globals.!ListTable || ParseHTML( Globals.!ETC || "\webmailhtml\listemails-table.wm",0,1 ) || '0d0a'x
 end
end; else Globals.!ListTable = "No mail"
call ParseHTML Globals.!ETC || "\webmailhtml\listemails.wm"
call ParseHTML Globals.!ETC || "\webmailhtml\footer.wm"
exit

NewEmailScreen: procedure expose Globals.
call ParseHTML Globals.!ETC || "\webmailhtml\header.wm", 1
call ParseHTML Globals.!ETC || "\webmailhtml\composeemail.wm"
call ParseHTML Globals.!ETC || "\webmailhtml\footer.wm"
exit

ReadEmailScreen: procedure expose Globals.
i=1
tmp1 = pos("From:",ARG(1))+6
tmp2 = pos('0d0a'x,ARG(1),tmp1)
tmp3 = space(substr(ARG(1),tmp1,tmp2-tmp1))
ListMail.i.!From = space(substr(tmp3,1,pos("<",tmp3)-1)||"("||substr(tmp3,pos("<",tmp3)+1,(lastpos(">",tmp3))-(pos("<",tmp3)+1))||")")
tmp1 = pos("Subject:",ARG(1))+9
tmp2 = pos('0d0a'x,ARG(1),tmp1)
ListMail.i.!Subject = space(substr(ARG(1),tmp1,tmp2-tmp1))
tmp1 = pos("Date:",ARG(1))+6
tmp2 = pos('0d0a'x,ARG(1),tmp1)
ListMail.i.!Date = space(substr(ARG(1),tmp1,16))
ListMail.!Show = substr(ARG(1),1,lastpos('0d0a'x||"."||'0d0a'x,ARG(1))-1)
call ParseHTML Globals.!ETC || "\webmailhtml\header.wm", 1
call ParseHTML Globals.!ETC || "\webmailhtml\reademail.wm"
call ParseHTML Globals.!ETC || "\webmailhtml\footer.wm"
exit

ServerErrorScreen: procedure expose Globals.
Globals.!ServerErr = ARG(1)
call ParseHTML Globals.!ETC || "\webmailhtml\servererror.wm", 1
exit

CGIErrorScreen: procedure expose Globals.
Globals.!CGIErr = ARG(1)
call ParseHTML Globals.!ETC || "\webmailhtml\cgierror.wm", 1
exit

URLDecode: procedure expose cgi.
line= ARG(1)
lineLen= LENGTH(line)
newLine= ''
i=1
do while i <= lineLen
 c= substr(line, i, 1)
 if c \= '%' then newLine = newLine || c
 else if i+2 <= lineLen then do
  newLine= newLine || x2c(substr(line, i+1, 2))
  i=i+2
 end
 i= i+1
end
RETURN newLine

